'******************************************************************************
' SMTP routines  V4          09.01.2011 HH     Netio+        (SVN rev.227)
'******************************************************************************

'*******************************************************************************
'  Pollin NET-IO Board with Atmega32 / 644 / 644P and ENC28J60
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'
'*******************************************************************************
$nocompile                                                  'will compile only as an include file

'-------------------------------------------------------------------------------
'  Smtp
'-------------------------------------------------------------------------------
 Const Smtp_my_smtp_server = 1                              '[evtl nicht hier hin]  1= login  (GMX) 2= keine login (t-online)
  Const Smtp_vers_ion = "V4 1/2011"



'***********************************************************************************************
'*  Wird von der Mainloop aufgerufen und prft ob eine Mail versand werden soll                *
'***********************************************************************************************
Smtp_inc_by_main_loop_7:                                    'Aufruf erfogt im Hauptprogramm aus der Main_Loop                                     '
' Freesol gendert
         If Smtp_mail_versand_in = 1 Then Decr Smtp_mail_versand_in       ' 1 Bedeutet Flag fr Mailaufruf gesetzt, 2 bedeutet keine Mail
         #if System_message > 0
          If Smtp_mail_versand_in > 0 Then
           ' Print "Mail_versand_in = " ; Smtp_mail_versand_in ; " Minuten "
          Else
            Print "Mail versand Start am " ; Date$ ; " um " ; Time$
          End If
         #endif
         If Smtp_mail_versand_in = 0 And Smtp_mail_gestartet = 0 Then       'And _sec = 18 Then
            Smtp_mail_versand_in = 10                       ' alle 30min wird gesendet
            Smtp_mail_zeile = 0
            Set Smtp_mail_gestartet

         #if System_message > 0
           If Smtp_mail_zweiter_versuch = 1 Then Print "Zweiter versuch"
         #endif
            Call Smtp_send_sync                             'Verbindung Aufbauen
            'Waitms 200
         End If
      Return                                                ' Ende zuruck zur Mainloop

Smtp_inc_by_main_loop_48:

       Reset Smtp_loop_bit

       If Smtp_mail_gestartet = 1 Then
            If Smtp_mail_vers_io = 1 Then

               #if System_message > 0
                  Print "Mail versand i.O."
                  Print
               #endif
               Incr Smtp_mail_anzahl
               Reset Smtp_mail_zweiter_versuch
            Else

                  Incr Smtp_mail_anzahl_gestrt
                  If Smtp_mail_verbindung_io = 1 Then
                        #if System_message > 0 : Print "keine Besttigung fr Mail versand " : #endif
                     Else
                        #if System_message > 0 : Print "Strung Mail Verbindung" : #endif
                  End If


                  If Smtp_mail_zweiter_versuch = 0 Then
                        Smtp_mail_versand_in = 1
                        Set Smtp_mail_zweiter_versuch
                  Else
                     Reset Smtp_mail_zweiter_versuch
            End If


         End If

         Reset Smtp_mail_gestartet
         Reset Smtp_mail_vers_io
         Reset Smtp_mail_verbindung_io
         Smtp_syn_status = 0

       End If



Return                                                      ' Ende zuruck zur Mainloop


'******************************************************************************************************************+





'************************************************************************
'*   Verarbeitet die Ankommenten Pakete vom Smtpserver                  *
'************************************************************************
 '-------------------------------------------------------------------------------
'    Ablaufsteuerung
'   nach ankommenden Flags in TCP werden die Funktionen aufgerufen
'-------------------------------------------------------------------------------
Sub Smtp
    #if Debug_smtp > 0 : Print "{013}{010} Smtp_Sub_start > Smtp_syn_status = " ; Smtp_syn_status : #endif

      If Smtp_syn_status < 6 Then


             If Tcp_syn = 1 And Tcp_ack = 1 Then
                Call Smtp_call_ack
                Smtp_syn_status = 1                         'Aufbau
               #if Debug_smtp > 0
                  Print "  ACK on ACK-SYN"
               #endif

             Elseif Tcp_psh = 1 And Tcp_ack = 1 Then
               If Smtp_syn_status < 2 Then Smtp_syn_status = 2
               #if Debug_smtp > 0
                  Print "  ACK on ACK-PSH "
               #endif
                Call Smtp_auswerten
                                  '                          'Smtp_syn_status = 3 bedeutet Login OK

             Elseif Tcp_ack = 1 And Smtp_noch_mail_pakete = 1 Then

                Smtp_syn_status = 4                         'mehr als ein Paket lange Mail
               #if Debug_smtp > 0
                  Print "  ACK und noch Paketen jetzt Status 4"
               #endif
                Call Smtp_auswerten

             End If
                                                              'Smtp_syn_status = 5 Mail ist raus
                                                              'Smtp_syn_status = 6 Server hat Aufwiedersehen gesendet

             Elseif Tcp_rst = 1 Then                        ' Abgebrochen
                   Smtp_syn_status = 8
                #if Debug_smtp > 0
                  Print "Abbruch wurde  vom Server ---> Wir sind unerwnscht :-( "
                #endif



         Else


            If Tcp_fin = 1 And Tcp_ack = 1 Then

                 Call Smtp_call_fin
                Smtp_syn_status = 7                         'Mail versand Verbindung beenden
               #if Debug_smtp > 0
                  Print "Ack und Fin kammen an ---> besttigen "
               #endif
                  Waitms 100
                 Call Smtp_call_fin
               #if Debug_smtp > 0
                  Print "und ein reset hinten nach  "
               #endif

            Else
            #if Debug_smtp > 0
              Print "Antwort nicht beachten{013}{010}"
            #endif

            End If

         End If

             #if Debug_smtp > 3
             Call Smtp_debug_flags
             #endif
End Sub

 '******************************************************************************************************************+
'-------------------------------------------------------------------------------
' SEND_SYNC
'  Einleiten der bertragung
'-------------------------------------------------------------------------------

  Sub Smtp_send_sync
     Call Clear_buffer
     Call Smtp_tcp_ip_header

#if Debug_smtp > 1
     Print "  Send SYNC "
#endif


     If Arp_request_destmac_for_ip(my_smtp_server_ip_addr(1)) = Nok Then
         ' can't connect!!! let's do the ARP request and start a new call after random Time
         #if Debug_smtp > 1
           Print "  No MAC!"
         #endif
         Call Arp_enqueue_ip(my_smtp_server_ip_addr(1))
         'in 1 Minute nochmal probieren...
         Smtp_mail_versand_in = 1
         Exit Sub
     End If

         Tcp_flags = 0
         Set Tcp_syn
         Tcp_seqnum = Netio_time
         Tcp_acknum = 0
         Ip_b_time_to_live = 128


         'Option Bytes
         Buffer(55) = &H02
         Buffer(56) = &H04
         Buffer(57) = &H05
         Buffer(58) = &HB4
         Buffer(59) = &H01
         Buffer(60) = &H03
         Buffer(61) = &H03
         Buffer(62) = &H02
         Buffer(63) = &H01
         Buffer(64) = &H01
         Buffer(65) = &H04
         Buffer(66) = &H02

         Tcp_hdr = &H80
         Call Set_ip_header_len(66)
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(66)


End Sub

 '-------------------------------------------------------------------------------
' Call_Ack
'  ACK
'-------------------------------------------------------------------------------
Sub Smtp_call_ack

          If Smtp_syn_status = 0 Then
            Smtp_syn_status = 2                             'Info
            Smtp_offset_ack = 1
                   'ENC28J60 doesn't handle Packets with less than 60 Bytes!
                     'Option Bytes
                  Buffer(55) = 0
                  Buffer(56) = 0
                  Buffer(57) = 0
                  Buffer(58) = 0
                  Buffer(59) = 0
                  Buffer(60) = 0
           End If

         Tcp_flags = 0
         Set Tcp_ack
         Call Tcp_swap_seq_ack(tcp_seqnum , Tcp_acknum , Smtp_offset_ack)
         Call Tcp_swap_ip
         Call Tcp_swap_mac
         Call Tcp_swap_port



         Tcp_hdr = &H50

         Call Set_ip_header_len(54)                         '<-- this will be set to 60 in ENC Routines!!!!
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(frame_size)                'send it
End Sub

'-------------------------------------------------------------------------------
' Smtp_auswerten
'-------------------------------------------------------------------------------
Sub Smtp_auswerten
       Local Smtp_local_tempstr As String * 50
       Local Smtp_local_packetlength As Word
       Local Smtp_local_z As Byte
       Local Ztemp As Byte
       Local Msg As String * 70
       Local Work As Word
       Local E As Word
       Local Char As String * 1
       Local S As String * 20
       Local D As Single

       Smtp_local_tempstr = ""
       Smtp_local_packetlength = T_ip_pktlen1 - 40
       Smtp_offset_ack = T_ip_pktlen1 - 40


       For Smtp_local_z = 1 To Smtp_local_packetlength
           Ztemp = Smtp_local_z + 54
           If Buffer(ztemp) = 10 Then Goto Z_next           'bei <CR>   =  then next Z   geht aber bei bascom nicht
           If Buffer(ztemp) = 13 Then Goto Z_next           'beo <LF>   =  then next Z   geht aber bei bascom nicht
           Smtp_local_tempstr = Smtp_local_tempstr + Chr(buffer(ztemp))
Z_next:
       Next Smtp_local_z

       Smtp_local_tempstr = Smtp_local_tempstr + "<"
          #if Debug_smtp > 1
                Print "SMTP > " ; Smtp_local_tempstr ; " Zeile =  " ; Smtp_mail_zeile ' " b> " ; Hilf_hh_b ' "  " Seq " ; Seqnum ; " Ack " ; Acknum       '; " 1> " ; T_ip_pktlen1 ; " TCP_hdr " ; Tcp_hdr
          #endif

       If Left(smtp_local_tempstr , 3) = "220" And Smtp_mail_zeile < 2 Then
           Smtp_mail_zeile = 1
           Set Smtp_mail_verbindung_io
           Smtp_mail_packetanzahl = 1                       'test

       End If

       If Left(smtp_local_tempstr , 3) = "250" And Smtp_mail_zeile < 2 Then Smtp_mail_zeile = 2
       If Left(smtp_local_tempstr , 6) = "334 VX" Then Smtp_mail_zeile = 3
       If Left(smtp_local_tempstr , 6) = "334 UG" Then Smtp_mail_zeile = 4
       If Left(smtp_local_tempstr , 3) = "235" And Smtp_mail_zeile = 4 Then Smtp_mail_zeile = 5
       If Left(smtp_local_tempstr , 3) = "250" And Smtp_mail_zeile = 6 Then Smtp_mail_zeile = 7
       If Left(smtp_local_tempstr , 7) = "250 2.1" And Smtp_mail_zeile = 5 Then
                        Smtp_mail_zeile = 6
                        Smtp_syn_status = 3                 'Info Login OK
       End If
       If Left(smtp_local_tempstr , 3) = "354" And Smtp_mail_zeile < 18 Then Incr Smtp_mail_zeile
       If Left(smtp_local_tempstr , 3) = "502" Or Smtp_mail_zeile > 101 Then Smtp_mail_zeile = 101
       If Left(smtp_local_tempstr , 6) = "221 2." And Smtp_mail_zeile > 99 Then Smtp_mail_zeile = 101
          'If Left(Smtp_local_tempstr , 9) = "535 5.7.0" Then  ' Incorrect username or password
          'If Left(Smtp_local_tempstr , 9) = "235 2.7.0" Then  ' Go ahead   --> username or password O.K.
          'If Left(Smtp_local_tempstr , 9) = "451 4.3.0" Then  ' Temporary problem

       If Left(smtp_local_tempstr , 9) = "354 mail."then    '354 mail.gmx.net Go ahead {mp006}
             Set Smtp_mail_paket_besttigt
                #if Debug_smtp > 1 : Print "nur besttigen__1 um Zeit zu gewinnen " : #endif
             Call Smtp_call_ack
             Set Smtp_mail_paket_besttigt
       End If

       If Left(smtp_local_tempstr , 9) = "221 2.0.0" Then   ' Bye Auf Wiedersehen
              Smtp_syn_status = 6
              Incr Smtp_mail_zeile
                   #if Debug_smtp > 1 : Print "bye bye nicht  besttigen" : #endif       'sonst wird die Verbinung wieder aufrecht erhalten !
              Exit Sub                                      'Goto Ende_der_sub
       End If

         #if Smtp_my_smtp_server = 1
       If Left(smtp_local_tempstr , 9) = "250 2.6.0" And Smtp_mail_zeile > 99 Then       '  Mail angenommen    250 2.6.0 Message accepted {mp014}
           'Waitms 150
         #else
       If Left(smtp_local_tempstr , 9) = "250 2.0.0" And Smtp_mail_zeile > 99 Then       '  Mail angenommen     '17
         #endif
         Smtp_mail_zeile = 101
         Set Smtp_mail_vers_io
         Smtp_syn_status = 5                                'Smtp_syn_status = 5 Mail ist raus
           #if Debug_smtp > 0 : Print "{013}{010}{013}{010}********************** Mail ist raus *************************{013}{010}" : #endif
       End If

' *** Zusammenstellen: ***

       Smtp_local_packetlength = 54

Neuezeile:

       Msg = ""
       Select Case Smtp_mail_zeile                          'Auswahl der Zeile die als nchstes gesendet werden mu

             Case 0 : Msg = "{013}{010}"
             Case 1 : Msg = "HELO AVR_NET_IO{013}{010}"
                #if Smtp_my_smtp_server = 1                 'GMX
                     Case 2 : Msg = "AUTH LOGIN{013}{010}"
                     Case 3 : Msg = Ee_s47_benutzerkennung  '  Benutzerkennung  64bitcodiert
                     Case 4 : Msg = Ee_s31_passwort         ' Passwort  64bitcodiert
                     Case 5 : Msg = "mail From : " + Smtp_s31_meine_email_adresse + " {013}{010}"       ' send from address
                #else                                       't-online
                     Case 2 : Mail_zeile = 6                ' keine login fr t-online da login ber den t-online anschlu erfolgt
                              Msg = "RCPT TO: " + Smtp_s31_meine_email_adresse + {013}{010} "       ' send TO address
                #endif

             Case 6 : Msg = "RCPT TO: " + Smtp_s31_empfaenger_mail_adresse + "{013}{010}"       ' send TO address
             Case 7 : Msg = "DATA{013}{010}"                ' speicfy that we are going to send data
             Case 8 : Msg = "From: " + Smtp_s31_meine_email_adresse + "{013}{010}"
             Case 9 : Msg = "To: " + Smtp_s31_empfaenger_mail_adresse + "{013}{010}"
             Case 10 : Msg = "Subject:Freesol-Bericht der Anlage " + Fs_mail_name + " fr den " + Fs_mail_datum + "{013}{010}"
             Case 11 : Msg = "Date: " + Smtp_s3_weekday + ", " + Str(_day) + " " + Smtp_s3_month + " " + Str(smtp_w_year) + " " + Time$
                                       If Ntp_it_summertime = 0 Then
                                          Msg = Msg + " +0100{013}{010}"       'winter +1
                                       Else
                                          Msg = Msg + " +0200{013}{010}"       'sommer +2
                                       End If

             Case 12 : Msg = "{013}{010}"                   'Zeile zum trennen von Kopf und Text
             Case 13 : D = Fs_anlagenleistung
                        D = D / 1000
                        S = Fusing(d , "##.##")
                        Msg = Ee_s12_hostname
                        Msg = "Modulleistung der Anlage " + Msg + ": " + S + " kW{013}{010}"
             Case 14 : Msg = "Freesol-Version: " + Fs_version + "{013}{010}"

             Case 15 : Msg = "{013}{010}"                   'Zeile zum trennen von Kopf und Text
             Case 16 : Msg = "Datum: " + Fs_mail_datum + "{013}{010}"
             Case 17 : D = Fs_mail_energie / 1000
                       S = Fusing(d , "##.##")
                       Msg = "Energie: " + S + " kWh{013}{010}"
             Case 18 : D = Fs_mail_energienorm
                        S = Fusing(d , "##.##")
                       Msg = "Energie normiert: " + S + " kWh/kWp{013}{010}"
             Case 19 : Msg = ".{013}{010}"                  ' end with a single dot
                        Smtp_mail_zeile = 100
             Case 100 : Msg = ".{013}{010}"                 ' end with a single dot
             Case 101 : Msg = "quit{013}{010}"              ' quit connection
             Case 102 : Msg = ""                            '
             Case 103 : Msg = ""                            '


        End Select

        If Tcp_psh = 1 Or Smtp_mail_paket_besttigt = 1 Or Smtp_noch_mail_pakete = 1 Then
              #if Debug_smtp > 1
                If Smtp_mail_zeile > 7 And Smtp_mail_zeile < 101 Then
                        Print "Zu_st. > " ; Smtp_mail_zeile ; " >" ; Msg ;
                End If
              #endif
            For Work = 1 To Len(msg)
              E = Smtp_local_packetlength + Work
              Char = Mid(msg , Work , 1)
              Buffer(e) = Asc(char)
            Next Work

            Smtp_local_packetlength = Smtp_local_packetlength + Len(msg)

            If Smtp_mail_zeile > 7 And Smtp_mail_zeile < 100 Then       '17
               Incr Smtp_mail_zeile
               If Smtp_local_packetlength < 1301 Then
                     Goto Neuezeile
               Else
                     #if Debug_smtp > 0
                        Print "{013}{010}Sende Paket da >=1300"
                     #endif
                  Set Smtp_noch_mail_pakete
                  Incr Smtp_mail_packetanzahl
               End If

            Else
                  #if Debug_smtp > 2
                     If Smtp_mail_zeile > 7 And Smtp_mail_zeile < 101 Then       '101
                        Print "Send > " ; Smtp_mail_zeile ; " >" ; " Die Zusammenstellung   ";

                   Else
                        Print "Send > " ; Smtp_mail_zeile ; " >" ; Msg ;
                     End If
                     Print "{013}{010}Packetlength = " ; Smtp_local_packetlength
                     Print "Mail_packetanzahl = " ; Smtp_mail_packetanzahl
                  #endif
            End If
         End If

         If Smtp_mail_zeile = 100 Then Incr Smtp_mail_zeile
         If Smtp_mail_zeile > 100 Then Reset Smtp_noch_mail_pakete

 '*******************

         Smtp_local_packetlength = Smtp_local_packetlength - 14

         If Smtp_mail_paket_besttigt = 0 Then
               Call Tcp_swap_seq_ack(tcp_seqnum , Tcp_acknum , Smtp_offset_ack)
               Call Tcp_swap_ip
               Call Tcp_swap_mac
               Call Tcp_swap_port
          Else
            Smtp_mail_paket_besttigt = 0
         End If

         Tcp_flags = 0
         Set Tcp_ack


         Tcp_hdr = &H50                                     '80

         Call Set_ip_header_len(54)                         '<-- this will be set to 60 in ENC Routines!!!!

            T_ip_pktlen0 = High(smtp_local_packetlength)
            T_ip_pktlen1 = Low(smtp_local_packetlength)
         Call Ip_header_checksum
         Call Tcp_checksum
          Smtp_local_packetlength = Smtp_local_packetlength + 14
         Call Enc28j60packetsend(smtp_local_packetlength)   'send it


End Sub



'-------------------------------------------------------------------------------
' Call_fin
'   FIN
'-------------------------------------------------------------------------------
Sub Smtp_call_fin
         Tcp_flags = 0

         If Smtp_syn_status = 7 Then
           Set Tcp_rst
         Else
            Set Tcp_fin
            Set Tcp_ack

            Call Tcp_swap_seq_ack(tcp_seqnum , Tcp_acknum , 1)
            Call Tcp_swap_ip
            Call Tcp_swap_mac
            Call Tcp_swap_port
         End If
         'ENC28J60 doesn't handle Packets with less than 60 Bytes!
         'Option Bytes
         Buffer(55) = 0
         Buffer(56) = 0
         Buffer(57) = 0
         Buffer(58) = 0
         Buffer(59) = 0
         Buffer(60) = 0

         Tcp_hdr = &H50

         Call Set_ip_header_len(54)
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(frame_size)                'send it
End Sub

'-------------------------------------------------------------------------------

 '-------------------------------------------------------------------------------
' Tcp_ip_header
'  erstellt den TCP/IP Header in "BUFFER"
'-------------------------------------------------------------------------------
Sub Smtp_tcp_ip_header
      ' *** ETH Header ***
          Eth_b_dest_mac(1) = &HFF
          Eth_b_dest_mac(2) = &HFF
          Eth_b_dest_mac(3) = &HFF
          Eth_b_dest_mac(4) = &HFF
          Eth_b_dest_mac(5) = &HFF
          Eth_b_dest_mac(6) = &HFF

          Eth_b_src_mac(1) = My_b_macaddr(1)
          Eth_b_src_mac(2) = My_b_macaddr(2)
          Eth_b_src_mac(3) = My_b_macaddr(3)
          Eth_b_src_mac(4) = My_b_macaddr(4)
          Eth_b_src_mac(5) = My_b_macaddr(5)
          Eth_b_src_mac(6) = My_b_macaddr(6)

          Eth_w_packettype = Eth_w_packettype_ip

      ' *** IP Header ***
          ' 14     Version=4 (obere 4 Bit)
          '        Headerlen:4-Bit (unter 4-Bit) Wert * 32 Bit = Bytes... Bsp.: 5 * 32Bit = 160Bit / 8 = 20 Byte
          Ip_b_vers_and_length = Ip_standard_vers_and_length
          ' 15     IHL=0 differntiated Service Field
          Ip_b_type_of_service = 0
          ' 16-17  Length IP-Header, TCP-Header and Payload
          Ip_w_packet_length = &H0034                       'Http_stack_headerlength(tempx)
          ' 18-19  Identification, will be incr by 1! fragmented Segmentes!!!
          Ip_w_identifier = &HC426                          'Http_stack_fragment(tempx)
          ' 20-21  always 0x40 0x00
          Ip_w_fragmentation = Reversed_word(&H4000)
          ' 22    Time to live (128)
          Ip_b_time_to_live = 128                           'Http_stack_lifetime(tempx)
          ' 23    TCP Protokoll 0x06
          Ip_b_protocol = Ip_protocol_tcp
          ' 24-25 IP-Header Checksum
          '*** will be generated later on send
          ' 26-29 IP Source Address
          T_ip_srcaddr0 = My_b_ipaddr(1)
          T_ip_srcaddr1 = My_b_ipaddr(2)
          T_ip_srcaddr2 = My_b_ipaddr(3)
          T_ip_srcaddr3 = My_b_ipaddr(4)
          ' 30-33 IP Destination Address
          T_ip_destaddr0 = My_smtp_server_ip_addr(1)
          T_ip_destaddr1 = My_smtp_server_ip_addr(2)
          T_ip_destaddr2 = My_smtp_server_ip_addr(3)
          T_ip_destaddr3 = My_smtp_server_ip_addr(4)

      ' *** TCP Header ***
          ' 34-35 Source Port
          Tcp_srcportl = My_smtp_server_port_l              'Http_stack_port_dest(tempx)
          Tcp_srcporth = My_smtp_server_port_h              'Http_stack_port_dest(tempx)
          ' 36-37 Destination Port
          Tcp_destportl = My_smtp_server_port_l             'Http_stack_port_src(tempx)
          Tcp_destporth = My_smtp_server_port_h             'Http_stack_port_src(tempx)
          ' 38-41 Sequnce number
'          Tcp_seqnum = Http_stack_seqnum(tempx)
          Tcp_seqnum = Netio_time                           'Http_stack_acknum(tempx)
          ' 42-45 Acknowledge number
'          Tcp_acknum = Http_stack_acknum(tempx)
          Tcp_acknum = 0                                    'Http_stack_seqnum(tempx)
          ' 46    Header Length  should be always 20 Byte!
          ' (obere 4 Bit) Wert * 32 Bit = Bytes... Bsp.: 5 * 32Bit = 160Bit / 8 = 20 Byte
          Tcp_hdr = &H50
          ' 47    TCP Flags
          Tcp_flags = &H18                                  'PSH, ACK
          ' 48-49 Window Size
          Tcp_win_size = Reversed_word(maxload)
          ' 50-51 TCP Checksum
          '*** will be generated later on send
          ' 52-53 0x0000

         ' Laut RFC 791 muss die TTL von Paketen auf jedem Router,
         ' den das Paket auf dem Weg vom Sender zum Ziel passiert,
         ' um mindestens 1 verringert werden.
         ' IP-Pakete mit einer aktuellen TTL von 0 werden vom Router verworfen.
         Ip_b_time_to_live = 128



' Update_month_weekd:
      Smtp_b_weekday = Dayofweek()                          'The Return-Value is in the range of 0 to 6, Monday starts with 0.
      Smtp_s3_weekday = Lookupstr(smtp_b_weekday , Wochentage)
      Smtp_s3_month = Lookupstr(_month , Monate)
      Smtp_w_year = 2000 + _year

      'Data ">1<" , ">2<" , ">3<" , ">4<" , ">5<" , ">6<" , ">7<" , ">8<" , ">9<" , ">A<" , ">B<" , ">C<"
Wochentage:
Data "Mon" , "Tue" , "Wed" , "Thu" , "Fri" , "Sat" , "Sun"  ' the range of 0 to 6, Monday starts with 0.


Monate:
Data ">0<" , "Jan" , "Feb" , "Mar" , "Apr" , "May" , "Jun" , "Jul" , "Aug" , "Sep" , "Oct" , "Nov" , "Dec"

End Sub



'-------------------------------------------------------------------------------
' Dump HTTP-FLAG
'-------------------------------------------------------------------------------
#if Debug_smtp > 3
Sub Smtp_debug_flags
     Print
     Print "-----------------"
     Print "- Incoming smtp -"
     Print "-----------------"
     Print "  FIN " ; Tcp_fin
     Print "  SYN " ; Tcp_syn
     Print "  RST " ; Tcp_rst
     Print "  PSH " ; Tcp_psh
     Print "  ACK " ; Tcp_ack
     Print "  URG " ; Tcp_urg
     Print
End Sub
#endif